from django.contrib.auth import get_user_model
from django.contrib.auth.mixins import UserPassesTestMixin
from django.contrib.auth.models import Group
from django.utils.translation import gettext as _
from django_tables2 import SingleTableView

from sharix_admin.tables import UserInfoTable
from django.views.generic import DetailView

from dbsynce.models import Company, Documents, DocumentFile

from .base import BaseView

class UserListView(UserPassesTestMixin, SingleTableView):
    table_class = UserInfoTable
    queryset = get_user_model().objects.all()
    template_name = 'sharix_admin/user_information.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context.update({
            'title': _('User Management'),
            'object_list': context['object_list'],
            'groups': Group.objects.all()
        })
        return context

    def test_func(self) -> bool or None:
        group_names = ('PROVIDER')
        if bool(self.request.user.groups.filter(name=group_names)) or self.request.user.is_superuser:
            return True
        return False

#TODO change to smth working
class UserDetailView(BaseView, DetailView):
#class UserDetailView(UserPassesTestMixin, DetailView):

#class PartnerDetailView(PartnerBaseView, DetailView):
#TODO - change to sharix user
    model = Company
#TODO create this template
#    template_name = 'sharix_admin/user_detail.html'
    template_name = 'sharix_admin/user_info.html'
    context_object_name = 'user_detail'
    page_title = 'Информация о пользователе'

#TODO change to smth about user
    def get_object(self, queryset=None):
        return get_object_or_404(Company, repr=self.request.user)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        if not pk:
            docs = Documents.objects.filter(
                user=pk,
                company=company.objects.filter(user=pk)
                ).prefetch_related('files').order_by('doc_type')
                #user=self.request.user,
                #company=self.object
            #).prefetch_related('files').order_by('doc_type')

            context.update({"docs": docs})
        else:
            docs = Documents.objects.filter(
                user=self.request.user,
                company=self.object
            ).prefetch_related('files').order_by('doc_type')

            context.update({"docs": docs})

        return context
